'''
Routines for contacting an authorization server to retrieve tokens for an ESG
file transfer using HTTP.

@author: cward
@organization: USC Information Sciences Institute
@deprecated: The authorization tokens used by this module are being replaced.
The HTTP protocol will not be supported by replication.
'''
import logging
from sys import stderr
from esgcet.publish.hessianlib import Hessian, ProtocolError, RemoteCallException
import configurationKeys as ckeys

_auth_service = None
"""
@type: Hessian connection object
"""
_trace_log = logging.getLogger('app.' + __name__)
"@type: logging.Logger"
#------------------------------------------------------------------------------
# get_authorization_tokens
#------------------------------------------------------------------------------
def get_authorization_tokens(source_urls, config):
  """
  Send the list of URLs to databases to the authorization token service.
  @param source_urls: URLs needing authorization tokens.
  @type source_urls: list
  @param config: The configuration dictionary
  @type config: ConfigParser
  @return: URLs with authorization tokens added.
  @rtype: list
  @deprecated: At one time, used for wget scripts.
  """
  _trace_log.info("Enter: %s", source_urls)
  
  print >>stderr, "\nAuthorization Tokens are not currently supported!"
  return source_urls;
  
  global _auth_service
  auth_urls = None

  try:
      if _auth_service == None:
          HESSIAN_URL = config.get(ckeys.SECTION, ckeys.AUTH_SERV_KEY)
          HESSIAN_PORT = config.getint(ckeys.SECTION, ckeys.AUTH_PORT_KEY)
          HESSIAN_CERT = config.get(ckeys.SECTION, ckeys.AUTH_CERT_KEY)
          _auth_service = Hessian(HESSIAN_URL, HESSIAN_PORT, 
                                 key_file=HESSIAN_CERT, 
                                 cert_file=HESSIAN_CERT, debug=True)

      auth_urls = _auth_service.generateAuthorizationTokens(source_urls)

  except ProtocolError:
    print >>stderr, "Hessian Library raised ProtocolError"
    _trace_log.exception("Hessian Library raised ProtocolError")
    raise

  except RemoteCallException:
    print >>stderr, "Hessian Library raised RemoteCallException"
    _trace_log.exception("Hessian Library raised RemoteCallException")
    raise

  except Exception:
    print >>stderr, "Exception getting authorization tokens"
    _trace_log.exception("Exception getting authorization tokens")
    raise

  _trace_log.info("Return: auth_urls=%s", auth_urls)
  return auth_urls
